﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.C1Schedule;

namespace SL_Scheduler_RemoveOverlapAppointment
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            DateTime dt = DateTime.Now.Date;

            Appointment ap = new Appointment();
            ap.Start = new DateTime(dt.Year, dt.Month, dt.Day, 03, 00, 00);
            ap.End = ap.Start.AddMinutes(30);
            ap.Subject = "Daily Team Meeting";
            ap.Location = "Meeting Room IV";
            ap.Label = c1Scheduler1.DataStorage.LabelStorage.Labels[5];
            c1Scheduler1.DataStorage.AppointmentStorage.Appointments.Add(ap);

            ap = new Appointment();
            ap.Start = new DateTime(dt.Year, dt.Month, dt.Day, 05, 00, 00);
            ap.End = ap.Start.AddMinutes(30);
            ap.Subject = "Regular Meeting";
            ap.Location = "Meeting Room V";
            ap.Label = c1Scheduler1.DataStorage.LabelStorage.Labels[5];
            ap.GetRecurrencePattern().RecurrenceType = RecurrenceTypeEnum.Daily;
            ap.GetRecurrencePattern().Occurrences = 10;
            c1Scheduler1.DataStorage.AppointmentStorage.Appointments.Add(ap);

            c1Scheduler1.BeforeAppointmentSave += new EventHandler<C1.Silverlight.Schedule.AppointmentActionEventArgs>(c1Scheduler1_BeforeAppointmentSave);
        }

        void c1Scheduler1_BeforeAppointmentSave(object sender, C1.Silverlight.Schedule.AppointmentActionEventArgs e)
        {
            if (e.Appointment.ParentCollection.Contains(e.Appointment))
                return;

            bool cancelAppointment = false;


            if (e.Appointment.AllDayEvent)
            {

                List<Appointment> app = new List<Appointment>();

                foreach (Appointment ap in c1Scheduler1.DataStorage.AppointmentStorage.Appointments)
                {

                    if (e.Appointment.Start.Date.ToShortDateString().Equals(ap.Start.Date.ToShortDateString()))
                        app.Add(ap);
                    else if (e.Appointment.End.AddMinutes(-1).ToShortDateString().Equals(ap.End.Date.ToShortDateString()))
                        app.Add(ap);
                    else if (ap.AllDayEvent)
                    {
                        if (e.Appointment.End.AddMinutes(-1).ToShortDateString().Equals(ap.End.AddMinutes(-1).ToShortDateString()))
                            app.Add(ap);
                    }
                    else if (ap.IsRecurring)
                    {
                        if (ap.Start > e.Appointment.End.AddMinutes(-1).Date)
                            continue;

                        var recurApp = from curAp in ap.GetRecurrencePattern().RemovedOccurrences
                                       where e.Appointment.Start.Date.ToShortDateString().Equals(curAp.Start.Date.ToShortDateString())
                                       select curAp;

                        if (recurApp.ToArray().Length == 0)
                            app.Add(ap);

                    }

                }

                if (app.Count > 0)
                {
                    cancelAppointment = true;
                }
            }
            else if (e.Appointment.IsOneDay)
            {

                List<Appointment> app = new List<Appointment>();

                foreach (Appointment ap in c1Scheduler1.DataStorage.AppointmentStorage.Appointments)
                {
                    string startDate = ap.Start.Date.ToShortDateString();
                    string endDate = ap.End.Date.ToShortDateString();

                    string currentStartDate = e.Appointment.Start.Date.ToShortDateString();
                    string currentEndDate = e.Appointment.End.Date.ToShortDateString();

                    if (ap.IsOneDay)
                    {
                        if (ap.AllDayEvent)
                            app.Add(ap);
                        else if (ap.Start.TimeOfDay.Equals(e.Appointment.Start.TimeOfDay) && ap.End.TimeOfDay.Equals(e.Appointment.End.TimeOfDay))
                            app.Add(ap);
                        else if (e.Appointment.End.TimeOfDay > ap.Start.TimeOfDay && e.Appointment.End.TimeOfDay <= ap.End.TimeOfDay)
                            app.Add(ap);
                        else if (e.Appointment.Start.TimeOfDay <= ap.Start.TimeOfDay && e.Appointment.End.TimeOfDay > ap.End.TimeOfDay)
                            app.Add(ap);
                    }
                    else
                    {
                        if (ap.AllDayEvent)
                        {
                            string tempEndDate = ap.End.Date.AddDays(-1).ToShortDateString();

                            if (currentStartDate.Equals(startDate) || currentStartDate.Equals(tempEndDate) ||
                                currentEndDate.Equals(startDate) || currentEndDate.Equals(tempEndDate))
                            {
                                app.Add(ap);
                            }
                        }
                        else if (e.Appointment.Start.Date > ap.Start.Date && e.Appointment.End.Date < ap.End.Date)
                            app.Add(ap);
                        else if (e.Appointment.Start.Date <= ap.Start.Date && e.Appointment.End.Date >= ap.End.Date)
                            app.Add(ap);
                        else if (e.Appointment.Start.Date >= ap.Start.Date && e.Appointment.End.Date <= ap.End.Date)
                            app.Add(ap);

                    }

                }

                if (app.ToArray().Length == 0)
                    return;



                foreach (Appointment listApp in app.ToList())
                {
                    if (listApp.IsRecurring)
                    {
                        cancelAppointment = true;
                        var recurApp = from ap in listApp.GetRecurrencePattern().RemovedOccurrences
                                       where e.Appointment.Start.Date.ToShortDateString().Equals(ap.Start.Date.ToShortDateString())
                                       select ap;

                        if (recurApp.ToArray().Length > 0)
                        {
                            cancelAppointment = false;
                        }
                    }
                    else if (e.Appointment.IsOneDay)
                    {
                        if (listApp.IsOneDay && listApp.Start.ToShortDateString().Equals(e.Appointment.Start.ToShortDateString())
                            || !listApp.IsOneDay)
                        {
                            cancelAppointment = true;
                            break;
                        }
                    }
                    else if (listApp.AllDayEvent)
                    {

                        if (listApp.Start.Date.ToShortDateString().Equals(e.Appointment.Start.Date.ToShortDateString()) ||
                            listApp.End.Date.AddMinutes(-1).ToShortDateString().Equals(e.Appointment.End.Date.ToShortDateString()))
                        {
                            cancelAppointment = true;
                            break;
                        }
                    }

                }
            }
            else if (!e.Appointment.IsOneDay)
            {

                List<Appointment> app = new List<Appointment>();

                foreach (Appointment ap in c1Scheduler1.DataStorage.AppointmentStorage.Appointments)
                {
                    string startDate = ap.Start.Date.ToShortDateString();
                    string endDate = ap.End.Date.ToShortDateString();

                    string currentStartDate = e.Appointment.Start.Date.ToShortDateString();
                    string currentEndDate = e.Appointment.End.Date.ToShortDateString();


                    if (ap.Start >= e.Appointment.Start && ap.End <= e.Appointment.End)
                        app.Add(ap);
                    else if (ap.Start > e.Appointment.Start && ap.Start < e.Appointment.End)
                    {
                        app.Add(ap);
                    }
                    else if (ap.End > e.Appointment.Start && ap.End < e.Appointment.End)
                    {
                        app.Add(ap);
                    }
                    else if (ap.IsRecurring)
                    {


                    }
                    else
                    {
                        if (ap.AllDayEvent)
                        {
                            string tempEndDate = ap.End.Date.AddDays(-1).ToShortDateString();

                            if (currentStartDate.Equals(startDate) || currentStartDate.Equals(tempEndDate) ||
                                currentEndDate.Equals(startDate) || currentEndDate.Equals(tempEndDate))
                            {
                                app.Add(ap);
                            }
                        }
                    }

                }

                if (app.ToArray().Length == 0)
                    return;
                else
                    cancelAppointment = true;
            }

            if (cancelAppointment == true)
            {
                MessageBox.Show("Appointment already exists for this period");
                e.Handled = true;
            }
        }


    }
}
